//C++
#ifndef FUNCWRAPPERS_H
#define FUNCWRAPPERS_H

// Generated by cxsetup.  Do not edit manually.

#ifdef __cplusplus
extern "C"
{
#endif

   // Wrapper declarations for calling from C and C++.
   // Assumes energy points to arrays of size nFlux+1, flux and fluxError
   // point to arrays of size nFlux (though they need not be initialized),
   // and params points to an array of size nPar for the particular model.
   // initStr may point to a valid character string or it may be NULL if unused.

      void C_agauss(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_agnsed(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_apec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_btapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bbody(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bbodyrad(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bexrav(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xsbexrav(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_bexriv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xsbexriv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_bknpower(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_brokenPowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_bkn2pow(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_broken2PowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_bmc(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bremss(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_brnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bvapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bvrnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bvtapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bvvapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bvvrnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_bvvtapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_c6mekl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_c6pmekl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_c6pvmkl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_c6vmekl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_carbatm(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cemekl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cevmkl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cemVMekal(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_cflow(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xscflw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_compbb(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_compmag(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_compLS(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_compPS(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xscompps(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_compST(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_comptb(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_compth(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xscompth(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_compTT(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cph(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cplinear(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cutoffpl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cutoffPowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_disk(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_diskir(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_diskbb(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_diskline(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_diskm(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_disko(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_diskpbb(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_diskpn(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_eplogpar(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_eqpair(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xseqpair(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_eqtherm(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xseqth(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_equil(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_expdec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_ezdiskbb(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_gaussian(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_gaussianLine(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_gadem(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_gaussDem(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_gnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_grad(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_grbcomp(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_grbm(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_hatm(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_jet(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_kerrbb(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_kerrd(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_kerrdisk(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_spin(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_kyconv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_kyrline(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_laor(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_laor2(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_logpar(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_lorentz(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_lorentzianLine(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_meka(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_mekal(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_mkcflow(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xsmkcf(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_nei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nlapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_npshock(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nsa(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nsagrav(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nsatmos(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nsmax(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nsmaxg(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nsx(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nteea(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xsnteea(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_nthComp(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_nthcomp(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_optxagn(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_optxagnf(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_pegpwrlw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_pexmon(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_pexrav(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xspexrav(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_pexriv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xspexriv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_plcabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_powerlaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_powerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_posm(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_pshock(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_qsosed(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_raymond(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_raysmith(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_redge(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_refsch(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_rnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_sedov(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_sirf(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_slimbh(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_smaug(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_snapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_srcut(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_sresc(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_ssa(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_step(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vbremss(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vcph(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vequil(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vgadem(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vgaussDem(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_vgnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vmeka(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vmekal(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vmcflow(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xsvmcf(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_vnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vnpshock(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_voigt(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_voigtLine(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_vpshock(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vraymond(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vraysmith(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_vrnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vsedov(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vtapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvgnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvnpshock(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvpshock(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvrnei(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvsedov(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vvtapec(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zagauss(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zbbody(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zbknpower(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zBrokenPowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_zbremss(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zcutoffpl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zcutoffPowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_zgauss(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xszgau(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_zlogpar(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zLogpar(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_zpowerlw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zpowerLaw(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_absori(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xsabsori(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_acisabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_constant(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cyclabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_dust(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_edge(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_expabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_expfac(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_gabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_gaussianAbsorptionLine(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_heilin(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_highecut(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_hrefl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_ismabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_lyman(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_notch(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_pcfabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_phabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_plabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_pwab(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xspwab(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_redden(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_smedge(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_spexpcut(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_superExpCutoff(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_spline(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_SSS_ice(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_swind1(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_TBabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tbabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_TBfeo(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tbfeo(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_TBgas(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tbgas(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_TBgrain(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tbgrain(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_TBvarabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tbvabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_TBpcf(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tbpcf(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_TBrel(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_tbrel(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_uvred(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_varabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vphabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_wabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_wndabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xion(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xscat(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xscatmodel(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_zbabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zdust(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zedge(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zhighect(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zigm(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zpcfabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zphabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zxipcf(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zredden(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zsmdust(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zTBabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_ztbabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_zvarabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zvfeabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zvphabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zwabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zwndabs(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cflux(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_clumin(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_cpflux(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_gsmooth(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_ireflect(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_ireflct(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_kdblur(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_kdblur2(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_kerrconv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_spinconv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_lsmooth(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_partcov(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_PartialCovering(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_rdblur(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_reflect(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_reflct(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);

      void C_rfxconv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_rgsxsrc(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_simpl(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vashift(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_vmshift(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_xilconv(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zashift(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_zmshift(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);
      void C_pileup(const double* energy, int nFlux, const double* params,
                int spectrumNumber, double* flux, double* fluxError,
                const char* initStr);



#ifdef __cplusplus
}
#endif

#ifdef __cplusplus

#include <xsTypes.h>
extern "C"
{
      void CXX_agauss(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_agnsed(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_apec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_btapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bbody(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bbodyrad(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bexrav(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bexriv(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bknpower(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bkn2pow(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bmc(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bremss(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_brnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bvapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bvrnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bvtapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bvvapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bvvrnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_bvvtapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_c6mekl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_c6pmekl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_c6pvmkl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_c6vmekl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_carbatm(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cemekl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cevmkl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cflow(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_compbb(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_compmag(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_compLS(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_compPS(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_compST(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_comptb(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_compth(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_compTT(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cph(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cplinear(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cutoffpl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_disk(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_diskir(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_diskbb(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_diskline(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_diskm(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_disko(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_diskpbb(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_diskpn(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_eplogpar(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_eqpair(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_eqtherm(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_equil(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_expdec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_ezdiskbb(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_gaussian(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_gadem(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_gnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_grad(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_grbcomp(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_grbm(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_hatm(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_jet(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kerrbb(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kerrd(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kerrdisk(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kyconv(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kyrline(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_laor(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_laor2(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_logpar(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_lorentz(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_meka(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_mekal(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_mkcflow(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nlapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_npshock(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nsa(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nsagrav(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nsatmos(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nsmax(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nsmaxg(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nsx(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nteea(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_nthComp(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_optxagn(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_optxagnf(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pegpwrlw(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pexmon(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pexrav(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pexriv(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_plcabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_powerlaw(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_posm(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pshock(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_qsosed(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_raymond(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_redge(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_refsch(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_rnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_sedov(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_sirf(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_slimbh(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_smaug(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_snapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_srcut(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_sresc(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_ssa(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_step(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_tapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vbremss(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vcph(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vequil(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vgadem(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vgnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vmeka(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vmekal(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vmcflow(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vnpshock(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_voigt(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vpshock(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vraymond(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vrnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vsedov(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vtapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvgnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvnpshock(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvpshock(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvrnei(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvsedov(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vvtapec(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zagauss(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zbbody(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zbknpower(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zbremss(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zcutoffpl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zgauss(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zlogpar(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zpowerlw(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_absori(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_acisabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_constant(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cyclabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_dust(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_edge(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_expabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_expfac(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_gabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_heilin(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_highecut(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_hrefl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_ismabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_lyman(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_notch(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pcfabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_phabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_plabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pwab(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_redden(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_smedge(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_spexpcut(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_spline(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_SSS_ice(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_swind1(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_TBabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_TBfeo(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_TBgas(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_TBgrain(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_TBvarabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_TBpcf(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_TBrel(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_uvred(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_varabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vphabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_wabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_wndabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_xion(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_xscat(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zbabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zdust(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zedge(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zhighect(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zigm(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zpcfabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zphabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zxipcf(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zredden(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zsmdust(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zTBabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zvarabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zvfeabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zvphabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zwabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zwndabs(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cflux(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_clumin(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_cpflux(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_gsmooth(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_ireflect(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kdblur(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kdblur2(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_kerrconv(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_lsmooth(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_partcov(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_rdblur(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_reflect(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_rfxconv(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_rgsxsrc(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_simpl(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vashift(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_vmshift(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_xilconv(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zashift(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_zmshift(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);
      void CXX_pileup(const RealArray& energyArray, const RealArray& params,
                int spectrumNumber, RealArray& fluxArray, RealArray& fluxErrArray,
                const string& initString);



}
#endif

#endif
